/*
 * arch/m68k/mvme166/166ints.c
 *
 * Copyright (C) 1995 Richard Hirst [richard@sleepie.demon.co.uk]
 *
 * based on amiints.c -- Amiga Linux interrupt handling code
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file README.legal in the main directory of this archive
 * for more details.
 *
 */


#include <linux/types.h>
#include <linux/config.h>
#include <linux/kernel.h>

#include <asm/system.h>
#include <asm/irq.h>

extern void cd2401_rxerr_interrupt(void);
extern void cd2401_modem_interrupt(void);
extern void cd2401_tx_interrupt(void);
extern void cd2401_rx_interrupt(void);
extern void NCR53c7x0_intr (int, struct pt_regs *);

/*
 * void mvme166_init_INTS (void)
 *
 * Parameters:	None
 *
 * Returns:	Nothing
 *
 * This function should be called during kernel startup to initialize
 * the mvme166 IRQ handling routines.
 */

void mvme166_init_INTS (void)
{
}

void mvme166_process_int (int level, struct intframe *fp)
{
	extern isrfunc (*tick_handler)();
	level += 64;
#if 0
	printk ("..mvme166_process_int(0x%02x)..", level);
#endif
	if (level == 0x68) {
		(*tick_handler)(0,fp,NULL);
		*(volatile unsigned long *)0xfff40074 = 0x01000000;
	}
	else if (level == 0x55 || level == 0x7f) {
		/* SCSI ints, or level 7 software ints, used for INTFLY
		 * emulation */
		NCR53c7x0_intr (level, fp);
	}
	else if (level == 0x5c) {
		cd2401_rxerr_interrupt();
	}
	else if (level == 0x5d) {
		cd2401_modem_interrupt();
	}
	else if (level == 0x5e) {
		cd2401_tx_interrupt();
	}
	else if (level == 0x5f) {
		cd2401_rx_interrupt();
	}
	else
		panic ("Unknown interrupt 0x%02x", level);
}
